{% include rust2rpm_target ~ "-header.spec.inc" ignore missing %}
# Generated by rust2rpm {{ rust2rpm_version }}
{% if rpm_bcond_check == 0 %}
{% for comment in rpm_bcond_check_comments %}
{{ comment }}
{% endfor %}
{% endif %}
%bcond check {{ rpm_bcond_check }}
{% if build_rustflags_debuginfo %}

# build with reduced debuginfo to work around memory limits
%global rustflags_debuginfo {{ build_rustflags_debuginfo }}
{% endif %}
{% if rpm_version != upstream_version %}

%global upstream_version {{ upstream_version }}
{% endif %}

Name:           {{ rpm_name }}
Version:        {{ rpm_version }}
Release:        {{ rpm_release }}
Summary:        {{ rpm_summary }}
{% if rpm_group %}
Group:          {{ rpm_group }}
{% endif %}

{% if rpm_vendor_source is none %}
SourceLicense:  {{ rpm_license|default("# FIXME") }}
{% endif %}
# FIXME: paste output of %%cargo_license_summary here
License:        # FIXME
# LICENSE.dependencies contains a full license breakdown
{% if rpm_license_comments is not none %}
{{ rpm_license_comments }}
{% endif %}

URL:            {{ rpm_url }}
Source:         {{ rpm_source_url }}
{% if rpm_vendor_source is not none %}
Source:         {{ rpm_vendor_source }}
{% endif %}
{% for source in rpm_extra_sources %}
{% for comment_line in source.comment_lines %}
{{ comment_line }}
{% endfor %}
Source{{ source.number }}:{{ source.whitespace }}{{ source.file }}
{% endfor %}
{% for patch in rpm_extra_patches %}
{% for comment_line in patch.comment_lines %}
{{ comment_line }}
{% endfor %}
Patch{{ patch.number }}:{{ patch.whitespace }}{{ patch.file }}
{% endfor %}

{% if conf_supported_arches %}
ExclusiveArch:  {{ conf_supported_arches }}
{% elif rust2rpm_target != "fedora" %}
ExclusiveArch:  %{rust_arches}

{% endif %}
BuildRequires:  {{ rust_packaging_dep }}
{% if include_build_requires and rpm_vendor_source is none %}
  {% for req in rpm_buildrequires %}
BuildRequires:  {{ req }}
  {% endfor %}
  {% if rpm_test_requires|length > 0 %}
%if %{with check}
    {% for req in rpm_test_requires %}
BuildRequires:  {{ req }}
    {% endfor %}
%endif
  {% endif %}
{% endif %}
  {% for req in conf_buildrequires %}
BuildRequires:  {{ req }}
  {% endfor %}
  {% if conf_test_requires %}
%if %{with check}
  {% for req in conf_test_requires %}
BuildRequires:  {{ req }}
  {% endfor %}
%endif
  {% endif %}
{% for req in conf_bin_requires %}
Requires:       {{ req }}
{% endfor %}

%global _description %{expand:
{% if rpm_description is none %}
%{summary}.
{%- else %}
{{ rpm_description }}
{%- endif %}
}

%description %{_description}

%prep
{% if rpm_version != upstream_version %}
%autosetup -n {{ rpm_name }}-%{upstream_version} -p1{{ rpm_autosetup_args}}
{% else %}
%autosetup -n {{ rpm_name }}-%{version} -p1{{ rpm_autosetup_args}}
{% endif %}
{% for command in rpm_prep_pre %}
{{ command }}
{% endfor %}
%cargo_prep{{ cargo_prep_args }}
{% for command in rpm_prep_post %}
{{ command }}
{% endfor %}

{% if not include_build_requires and rpm_vendor_source is none %}
%generate_buildrequires
%cargo_generate_buildrequires{{ cargo_args }}

{% endif %}
%build
{% for command in rpm_build_pre %}
{{ command }}
{% endfor %}
%cargo_build{{ cargo_args }}
%{cargo_license_summary{{ cargo_args }}}
%{cargo_license{{ cargo_args }}} > LICENSE.dependencies
{% if rpm_vendor_source is not none %}
%{cargo_vendor_manifest}
{% endif %}
{% for command in rpm_build_post %}
{{ command }}
{% endfor %}

%install
{% for command in rpm_install_pre %}
{{ command }}
{% endfor %}
{% if rpm_cdylib_package and rpm_binary_names|length >= 1 %}
%cargo_install{{ cargo_args }}
{% if not conf_suppress_cdylib_install_fixme %}
# FIXME: install shared library
{% endif %}
{% elif rpm_cdylib_package %}
{% if not conf_suppress_cdylib_install_fixme %}
# FIXME: install shared library
{% endif %}
{% else %}
%cargo_install{{ cargo_args }}
{% for rpm_bin_rename in rpm_bin_renames %}
{{ rpm_bin_rename }}
{% endfor %}
{% endif %}
{% for command in rpm_install_post %}
{{ command }}
{% endfor %}

%if %{with check}
%check
{% for command in rpm_check_pre %}
{{ command }}
{% endfor %}
{% if cargo_test_commands %}
{% for command in cargo_test_commands %}
{{ command }}
{% endfor %}
{% else %}
%cargo_test{{ cargo_args }}
{% endif %}
{% for command in rpm_check_post %}
{{ command }}
{% endfor %}
%endif

%files
  {% if rpm_license_files|length > 0 %}
    {% for file in rpm_license_files %}
%license {{ file }}
    {% endfor %}
  {% else %}
# FIXME: no license files detected
  {% endif %}
%license LICENSE.dependencies
{% if rpm_vendor_source is not none %}
%license cargo-vendor.txt
{% endif %}
  {% for file in rpm_doc_files %}
%doc {{ file }}
  {% endfor %}
  {% for bin in rpm_binary_names %}
%{_bindir}/{{ bin }}
  {% endfor %}
  {% for file in rpm_extra_files %}
{{ file }}
  {% endfor %}

%changelog
{% if use_rpmautospec %}
%autochangelog
{%- else %}
{%- if make_changelog_entry -%}

  {% include rust2rpm_target ~ "-changelog.spec.inc" %}
{% endif %}
{% endif %}
